diff -urpN ksmbd-tools-3.1.0/lib/usmbdtools.c ksmbd-tools-3.1.0.new/lib/usmbdtools.c
--- ksmbd-tools-3.1.0/lib/usmbdtools.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/lib/usmbdtools.c	2020-01-27 13:31:02.065751274 +0400
@@ -6,15 +6,206 @@
  */
 
 #include <syslog.h>
-#include <glib/gi18n.h>
+#include <iconv.h>
 
 #include <unistd.h>
 #include <sys/stat.h>
 #include <fcntl.h>
+#include <ctype.h>
 
 #include <stdio.h>
+#include <stdarg.h>
 #include <usmbdtools.h>
 
+/*
+ * special simple linked list implementation, just made for the need of usmbd.
+ * not yet optimized
+ */
+
+struct LIST *list_init(struct LIST **list)
+{
+	*list = malloc(sizeof(struct LIST));
+	if (!*list)
+		return NULL;
+	(*list)->prev = NULL;
+	(*list)->next = NULL;
+	return *list;
+}
+
+long long list_maxid(struct LIST **list)
+{
+	long long id = -1;
+	struct LIST *head = *list;
+
+	while ((head = head->next)) {
+		if (((long long)head->id) >= id)
+			id = head->id;
+	}
+	return id;
+}
+
+int list_foreach(struct LIST **list,
+		 void (*func)(void *item, unsigned long long id,
+			      void *user_data), void *user_data)
+{
+	struct LIST *head = *list;
+
+	while ((head = head->next)) {
+		if (head->type == KEY_STRING)
+			func(head->item, list_tokey(head->keystr), user_data);
+		else
+			func(head->item, head->id, user_data);
+	}
+}
+
+struct LIST *head_get(struct LIST **list, unsigned long long id)
+{
+	struct LIST *head = *list;
+	struct LIST *last = NULL;
+
+	head = *list;
+	while ((head = head->next)) {
+		if (head == last) {
+			/* should not happen. if this triggers we have a bug */
+			pr_debug("fixup list\n");
+			head->next = NULL;
+			break;
+		}
+		last = head;
+		if (head->type == KEY_STRING) {
+			char *c = (char *)list_fromkey(id);
+
+			if (!strcmp(head->keystr, c))
+				return head;
+		} else {
+			if (head->id == id)
+				return head;
+		}
+	}
+	return NULL;
+}
+
+int _list_add(struct LIST **list, void *item, unsigned long long id, char *str)
+{
+	int ret = 1;
+	struct LIST *new;
+
+	if (!*list)
+		list_init(list);
+	new = head_get(list, str ? list_tokey(str) : id);
+	if (new)
+		ret = 0;
+	if (!new)
+		new = malloc(sizeof(struct LIST));
+	if (!new)
+		return 0;
+
+	new->item = item;
+	if (ret) {
+		if (str) {
+			new->keystr = str;
+			new->type = KEY_STRING;
+		} else {
+			new->id = id;
+			new->type = KEY_ID;
+		}
+		new->next = NULL;
+		struct LIST *head = *list;
+		struct LIST *last = head;
+
+		while ((head = head->next))
+			last = head;
+
+		last->next = new;
+		new->prev = last;
+	}
+	return ret;
+}
+
+int list_add(struct LIST **list, void *item, unsigned long long id)
+{
+	return _list_add(list, item, id, NULL);
+}
+
+int list_add_str(struct LIST **list, void *item, char *str)
+{
+	return _list_add(list, item, 0, str);
+}
+
+void list_append(struct LIST **list, void *item)
+{
+	_list_add(list, item, list_maxid(list) + 1, NULL);
+}
+
+int _list_remove(struct LIST **list, unsigned long long id, int dec)
+{
+	int ret = 0;
+	struct LIST *head = *list;
+	struct LIST *next = NULL;
+
+	while ((head = head->next)) {
+		if ((head->type == KEY_ID && head->id == id)
+		    || (head->type == KEY_STRING
+			&& !strcmp(head->keystr, list_fromkey(id)))) {
+			if (head->prev)
+				head->prev->next = head->next;
+
+			if (head->next) {
+				next = head->next;
+				head->next->prev = head->prev;
+			}
+
+			free(head);
+			ret = 1;
+			goto out;
+		}
+	}
+out:
+	if (dec && !ret && next) {
+		/* reorder all following ids after removing slot */
+		while (next) {
+			next->id = next->prev->id + 1;
+			next = next->next;
+		}
+	}
+	return ret;
+}
+
+int list_remove_dec(struct LIST **list, unsigned long long id)
+{
+	return _list_remove(list, id, 1);
+}
+
+int list_remove(struct LIST **list, unsigned long long id)
+{
+	return _list_remove(list, id, 0);
+}
+
+void *list_get(struct LIST **list, unsigned long long id)
+{
+	struct LIST *head = head_get(list, id);
+
+	if (head)
+		return head->item;
+	return NULL;
+}
+
+void list_clear(struct LIST **list)
+{
+	struct LIST *head = *list;
+
+	if (head)
+		return;
+
+	while (head) {
+		struct LIST *h = head->next;
+
+		free(head);
+		head = h;
+	}
+	*list = NULL;
+}
+
 static const char *app_name = "unknown";
 static int log_open;
 
@@ -137,40 +328,233 @@ void pr_hex_dump(const void *mem, size_t
 }
 #endif
 
+void base64_init_encodestate(base64_encodestate *state_in)
+{
+	state_in->step = step_A;
+	state_in->result = 0;
+	state_in->stepcount = 0;
+}
+
+char base64_encode_value(char value_in)
+{
+	static const char *encoding =
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
+
+	if (value_in > 63)
+		return '=';
+	return encoding[(int)value_in];
+}
+
+int base64_encode_block(const char *plaintext_in, int length_in, char *code_out,
+			base64_encodestate *state_in)
+{
+	const char *plainchar = plaintext_in;
+	const char *const plaintextend = plaintext_in + length_in;
+	char *codechar = code_out;
+	char result;
+	char fragment;
+
+	result = state_in->result;
+
+	switch (state_in->step) {
+		while (1) {
+		case step_A:
+			if (plainchar == plaintextend) {
+				state_in->result = result;
+				state_in->step = step_A;
+				return codechar - code_out;
+			}
+			fragment = *plainchar++;
+			result = (fragment & 0x0fc) >> 2;
+			*codechar++ = base64_encode_value(result);
+			result = (fragment & 0x003) << 4;
+		case step_B:
+			if (plainchar == plaintextend) {
+				state_in->result = result;
+				state_in->step = step_B;
+				return codechar - code_out;
+			}
+			fragment = *plainchar++;
+			result |= (fragment & 0x0f0) >> 4;
+			*codechar++ = base64_encode_value(result);
+			result = (fragment & 0x00f) << 2;
+		case step_C:
+			if (plainchar == plaintextend) {
+				state_in->result = result;
+				state_in->step = step_C;
+				return codechar - code_out;
+			}
+			fragment = *plainchar++;
+			result |= (fragment & 0x0c0) >> 6;
+			*codechar++ = base64_encode_value(result);
+			result = (fragment & 0x03f) >> 0;
+			*codechar++ = base64_encode_value(result);
+
+			++(state_in->stepcount);
+		}
+	}
+	/* control should not reach here */
+	return codechar - code_out;
+}
+
+int base64_encode_blockend(char *code_out, base64_encodestate *state_in)
+{
+	char *codechar = code_out;
+
+	switch (state_in->step) {
+	case step_B:
+		*codechar++ = base64_encode_value(state_in->result);
+		break;
+	case step_C:
+		*codechar++ = base64_encode_value(state_in->result);
+		break;
+	case step_A:
+		break;
+	}
+	*codechar++ = 0;
+	return codechar - code_out;
+}
+
 char *base64_encode(unsigned char *src, size_t srclen)
 {
-	return g_base64_encode(src, srclen);
+	char *out = malloc((srclen / 3 + 1) * 4 + 1);
+	base64_encodestate state;
+
+	base64_init_encodestate(&state);
+	int len = base64_encode_block(src, srclen, out, &state);
+
+	base64_encode_blockend(out + len, &state);
+	return out;
+}
+
+int base64_decode_value(char value_in)
+{
+	static const char decoding[] = {
+		62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1,
+		-1, -1, -2, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
+		    12, 13, 14, 15, 16, 17,
+		18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27,
+		    28, 29, 30, 31, 32, 33,
+		34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
+		    50, 51
+	};
+	static const char decoding_size = sizeof(decoding);
+
+	value_in -= 43;
+	if (value_in < 0 || value_in > decoding_size)
+		return -1;
+	return decoding[(int)value_in];
+}
+
+void base64_init_decodestate(base64_decodestate *state_in)
+{
+	state_in->step = step_a;
+	state_in->plainchar = 0;
+}
+
+int base64_decode_block(const char *code_in, int length_in, char *plaintext_out,
+			const int outlen, base64_decodestate *state_in)
+{
+	const char *codechar = code_in;
+	char *plainchar = plaintext_out;
+	char fragment;
+	int count = 0;
+
+	*plainchar = state_in->plainchar;
+
+	switch (state_in->step) {
+		while (1) {
+		case step_a:
+			do {
+				if (codechar == code_in + length_in) {
+					state_in->step = step_a;
+					state_in->plainchar = *plainchar;
+					return plainchar - plaintext_out;
+				}
+				fragment =
+				    (char)base64_decode_value(*codechar++);
+			} while (fragment < 0);
+			if (count > outlen)
+				return plainchar - plaintext_out;
+			*plainchar = (fragment & 0x03f) << 2;
+		case step_b:
+			do {
+				if (codechar == code_in + length_in) {
+					state_in->step = step_b;
+					state_in->plainchar = *plainchar;
+					return plainchar - plaintext_out;
+				}
+				fragment =
+				    (char)base64_decode_value(*codechar++);
+			} while (fragment < 0);
+			count += 1;
+			if (count > outlen)
+				return plainchar - plaintext_out;
+			*plainchar++ |= (fragment & 0x030) >> 4;
+			*plainchar = (fragment & 0x00f) << 4;
+		case step_c:
+			do {
+				if (codechar == code_in + length_in) {
+					state_in->step = step_c;
+					state_in->plainchar = *plainchar;
+					return plainchar - plaintext_out;
+				}
+				fragment =
+				    (char)base64_decode_value(*codechar++);
+			} while (fragment < 0);
+			count += 1;
+			if (count > outlen)
+				return plainchar - plaintext_out;
+			*plainchar++ |= (fragment & 0x03c) >> 2;
+			*plainchar = (fragment & 0x003) << 6;
+		case step_d:
+			do {
+				if (codechar == code_in + length_in) {
+					state_in->step = step_d;
+					state_in->plainchar = *plainchar;
+					return plainchar - plaintext_out;
+				}
+				fragment =
+				    (char)base64_decode_value(*codechar++);
+			} while (fragment < 0);
+			count++;
+			if (count > outlen)
+				return plainchar - plaintext_out;
+			*plainchar++ |= (fragment & 0x03f);
+		}
+	}
+	/* control should not reach here */
+	return plainchar - plaintext_out;
 }
 
 unsigned char *base64_decode(char const *src, size_t *dstlen)
 {
-	unsigned char *ret = g_base64_decode(src, dstlen);
+	base64_decodestate state;
 
-	if (ret)
-		ret[*dstlen] = 0x00;
-	return ret;
+	base64_init_decodestate(&state);
+	int len = ((strlen(src) / 4) * 3) + 1;
+	char *out = malloc(len);
+	*dstlen = base64_decode_block(src, strlen(src), out, len, &state);
+	return out;
 }
 
 static int codeset_has_altname(int codeset)
 {
 	if (codeset == USMBD_CHARSET_UTF16LE ||
-			codeset == USMBD_CHARSET_UTF16BE)
+	    codeset == USMBD_CHARSET_UTF16BE)
 		return 1;
 	return 0;
 }
 
-gchar *usmbd_gconvert(const gchar *str,
-		      gssize       str_len,
-		      int          to_codeset,
-		      int          from_codeset,
-		      gsize       *bytes_read,
-		      gsize       *bytes_written)
+char *usmbd_gconvert(const char *str, size_t str_len, int to_codeset,
+		     int from_codeset, size_t *bytes_read,
+		     size_t *bytes_written)
 {
-	gchar *converted;
-	GError *err;
+	char *converted, *buf;
+	int err;
 
 retry:
-	err = NULL;
+	err = 0;
 	if (from_codeset >= USMBD_CHARSET_MAX) {
 		pr_err("Unknown source codeset: %d\n", from_codeset);
 		return NULL;
@@ -180,15 +564,19 @@ retry:
 		pr_err("Unknown target codeset: %d\n", to_codeset);
 		return NULL;
 	}
-
-	converted = g_convert(str,
-			      str_len,
-			      usmbd_conv_charsets[to_codeset],
-			      usmbd_conv_charsets[from_codeset],
-			      bytes_read,
-			      bytes_written,
-			      &err);
-	if (err) {
+	buf = converted = malloc((str_len * 2) + 1);
+	memset(converted, 0, (str_len * 2) + 1);
+	iconv_t conv = iconv_open(usmbd_conv_charsets[to_codeset],
+				  usmbd_conv_charsets[from_codeset]);
+	*bytes_read = str_len;
+	*bytes_written = str_len * 2;
+	err = iconv(conv, (char **)&str, bytes_read, &converted, bytes_written);
+	*bytes_read = 0;
+	err = iconv(conv, NULL, bytes_read, &converted, bytes_written);
+	iconv_close(conv);
+	*bytes_written = (str_len * 2) - *bytes_written;
+	*bytes_read = str_len - *bytes_read;
+	if (err < 0) {
 		int has_altname = 0;
 
 		if (codeset_has_altname(to_codeset)) {
@@ -201,9 +589,6 @@ retry:
 			has_altname = 1;
 		}
 
-		pr_info("%s\n", err->message);
-		g_error_free(err);
-
 		if (has_altname) {
 			pr_info("Will try '%s' and '%s'\n",
 				usmbd_conv_charsets[to_codeset],
@@ -211,17 +596,66 @@ retry:
 			goto retry;
 		}
 
-		pr_err("Can't convert string: %s\n", err->message);
-		g_error_free(err);
 		return NULL;
 	}
 
-	return converted;
+	return buf;
+}
+
+static pthread_mutex_t atomic_lock = PTHREAD_MUTEX_INITIALIZER;
+
+int atomic_int_add(volatile int *atomic, int val)
+{
+	int oldval;
+
+	pthread_mutex_lock(&atomic_lock);
+	oldval = *atomic;
+	*atomic = oldval + val;
+	pthread_mutex_unlock(&atomic_lock);
+	return oldval;
+}
+
+void atomic_int_inc(volatile int *atomic)
+{
+	pthread_mutex_lock(&atomic_lock);
+	(*atomic)++;
+	pthread_mutex_unlock(&atomic_lock);
+}
+
+int atomic_int_compare_and_exchange(volatile int *atomic, int oldval,
+				    int newval)
+{
+	int success;
+
+	pthread_mutex_lock(&atomic_lock);
+	success = (*atomic == oldval);
+	if (success)
+		*atomic = newval;
+
+	pthread_mutex_unlock(&atomic_lock);
+
+	return success;
+}
+
+char *ascii_strdown(char *str, size_t len)
+{
+	char *result, *s;
+
+	if (!str)
+		return NULL;
+
+	if (len < 0)
+		len = strlen(str);
+
+	result = strndup(str, len);
+	for (s = result; *s; s++)
+		*s = tolower(*s);
+	return result;
 }
 
 void notify_usmbd_daemon(void)
 {
-	char manager_pid[10] = {0, };
+	char manager_pid[10] = { 0, };
 	int pid = 0;
 	int lock_fd;
 
diff -urpN ksmbd-tools-3.1.0/smbshareadd/Makefile.am ksmbd-tools-3.1.0.new/smbshareadd/Makefile.am
--- ksmbd-tools-3.1.0/smbshareadd/Makefile.am	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/smbshareadd/Makefile.am	2020-01-25 02:06:37.334284742 +0400
@@ -1,6 +1,6 @@
 AM_CFLAGS = -I$(top_srcdir)/include $(GLIB_CFLAGS) $(LIBNL_CFLAGS) -fno-common
 LIBS = $(GLIB_LIBS)
-smbshareadd_LDADD = $(top_builddir)/lib/libusmbdtools.la
+smbshareadd_LDADD = $(top_builddir)/lib/libusmbdtools.la -lpthread
 
 sbin_PROGRAMS = smbshareadd
 
diff -urpN ksmbd-tools-3.1.0/smbshareadd/share_admin.c ksmbd-tools-3.1.0.new/smbshareadd/share_admin.c
--- ksmbd-tools-3.1.0/smbshareadd/share_admin.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/smbshareadd/share_admin.c	2020-01-26 13:58:13.876726005 +0400
@@ -5,7 +5,6 @@
  *   linux-cifsd-devel@lists.sourceforge.net
  */
 
-#include <glib.h>
 #include <stdlib.h>
 #include <stdio.h>
 #include <unistd.h>
@@ -34,7 +33,7 @@ static char *new_group_name(char *name)
 	if (strchr(name, '['))
 		return name;
 
-	gn = g_malloc(strlen(name) + 3);
+	gn = malloc(strlen(name) + 3);
 	if (gn)
 		sprintf(gn, "[%s]", name);
 	return gn;
@@ -44,7 +43,7 @@ static char *aux_group_name(char *name)
 {
 	char *gn;
 
-	gn = g_malloc(strlen(name) + 3 + strlen(AUX_GROUP_PREFIX));
+	gn = malloc(strlen(name) + 3 + strlen(AUX_GROUP_PREFIX));
 	if (gn)
 		sprintf(gn, "[%s%s]", AUX_GROUP_PREFIX, name);
 	return gn;
@@ -85,16 +84,15 @@ static void __write(void)
 	}
 }
 
-static void __write_share(gpointer key, gpointer value, gpointer buf)
+static void __write_share(void *value, unsigned long long key, void *buf)
 {
-	char *k = (char *)key;
+	char *k = (char *)list_fromkey(key);
 	char *v = (char *)value;
 
 	wsz = snprintf(wbuf, sizeof(wbuf), "\t%s = %s\n", k, v);
 	if (wsz > sizeof(wbuf)) {
 		pr_err("smb.conf entry size is above the limit: %zu > %zu\n",
-			wsz,
-			sizeof(wbuf));
+		       wsz, sizeof(wbuf));
 		exit(EXIT_FAILURE);
 	}
 	__write();
@@ -106,10 +104,11 @@ static void write_share(struct smbconf_g
 
 	wsz = snprintf(wbuf, sizeof(wbuf), "[%s]\n", g->name);
 	__write();
-	g_hash_table_foreach(g->kv, __write_share, NULL);
+	list_foreach(&g->kv, __write_share, NULL);
 }
 
-static void write_share_cb(gpointer key, gpointer value, gpointer share_data)
+static void write_share_cb(void *value, unsigned long long key,
+			   void *share_data)
 {
 	struct smbconf_group *g = (struct smbconf_group *)value;
 
@@ -120,13 +119,12 @@ static void write_share_cb(gpointer key,
 		write_share(g);
 }
 
-static void write_remove_share_cb(gpointer key,
-				  gpointer value,
-				  gpointer name)
+static void write_remove_share_cb(void *value,
+				  unsigned long long key, void *name)
 {
 	struct smbconf_group *g = (struct smbconf_group *)value;
 
-	if (!g_ascii_strcasecmp(g->name, name)) {
+	if (!strcasecmp(g->name, name)) {
 		pr_info("share '%s' removed\n", g->name);
 		return;
 	}
@@ -134,26 +132,25 @@ static void write_remove_share_cb(gpoint
 	write_share(g);
 }
 
-static void update_share_cb(gpointer key,
-			    gpointer value,
-			    gpointer g)
+static void update_share_cb(void *value, unsigned long long key, void *g)
 {
+	struct LIST *list = (struct LIST *)g;
 	char *nk, *nv;
 
-	nk = g_strdup(key);
-	nv = g_strdup(value);
+	nk = strdup(list_fromkey(key));
+	nv = strdup(value);
 	if (!nk || !nv)
 		exit(EXIT_FAILURE);
 
 	/* This will call .dtor for already existing key/value pairs */
-	g_hash_table_insert(g, nk, nv);
+	list_add_str(&list, nv, nk);
 }
 
 int command_add_share(char *smbconf, char *name, char *opts)
 {
 	char *new_name = NULL;
 
-	if (g_hash_table_lookup(parser.groups, name)) {
+	if (list_get(&parser.groups, list_tokey(name))) {
 		pr_err("Share already exists: %s\n", name);
 		return -EEXIST;
 	}
@@ -164,13 +161,13 @@ int command_add_share(char *smbconf, cha
 
 	if (__open_smbconf(smbconf))
 		goto error;
-	g_hash_table_foreach(parser.groups, write_share_cb, NULL);
+	list_foreach(&parser.groups, write_share_cb, NULL);
 	close(conf_fd);
-	g_free(new_name);
+	free(new_name);
 	return 0;
 
 error:
-	g_free(new_name);
+	free(new_name);
 	return -EINVAL;
 }
 
@@ -180,7 +177,7 @@ int command_update_share(char *smbconf,
 	struct smbconf_group *update_group;
 	char *aux_name = NULL;
 
-	existing_group = g_hash_table_lookup(parser.groups, name);
+	existing_group = list_get(&parser.groups, list_tokey(name));
 	if (!existing_group) {
 		pr_err("Unknown share: %s\n", name);
 		goto error;
@@ -192,26 +189,24 @@ int command_update_share(char *smbconf,
 
 	/* get rid of [] */
 	sprintf(aux_name, "%s%s", AUX_GROUP_PREFIX, name);
-	update_group = g_hash_table_lookup(parser.groups, aux_name);
+	update_group = list_get(&parser.groups, list_tokey(aux_name));
 	if (!update_group) {
 		pr_err("Cannot find the external group\n");
 		goto error;
 	}
 
-	g_hash_table_foreach(update_group->kv,
-			     update_share_cb,
-			     existing_group->kv);
+	list_foreach(&update_group->kv, update_share_cb, existing_group->kv);
 
 	if (__open_smbconf(smbconf))
 		goto error;
 
-	g_hash_table_foreach(parser.groups, write_share_cb, NULL);
+	list_foreach(&parser.groups, write_share_cb, NULL);
 	close(conf_fd);
-	g_free(aux_name);
+	free(aux_name);
 	return 0;
 
 error:
-	g_free(aux_name);
+	free(aux_name);
 	return -EINVAL;
 }
 
@@ -220,9 +215,7 @@ int command_del_share(char *smbconf, cha
 	if (__open_smbconf(smbconf))
 		return -EINVAL;
 
-	g_hash_table_foreach(parser.groups,
-			     write_remove_share_cb,
-			     name);
+	list_foreach(&parser.groups, write_remove_share_cb, (void *)name);
 	close(conf_fd);
 	return 0;
 }
diff -urpN ksmbd-tools-3.1.0/smbshareadd/smbshareadd.c ksmbd-tools-3.1.0.new/smbshareadd/smbshareadd.c
--- ksmbd-tools-3.1.0/smbshareadd/smbshareadd.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/smbshareadd/smbshareadd.c	2020-01-25 02:01:29.299043469 +0400
@@ -4,8 +4,6 @@
  *
  *   linux-cifsd-devel@lists.sourceforge.net
  */
-
-#include <glib.h>
 #include <stdlib.h>
 #include <stdio.h>
 #include <unistd.h>
@@ -109,15 +107,15 @@ int main(int argc, char *argv[])
 	while ((c = getopt(argc, argv, "c:a:d:u:p:o:Vvh")) != EOF)
 		switch (c) {
 		case 'a':
-			arg_name = g_ascii_strdown(optarg, strlen(optarg));
+			arg_name = ascii_strdown(optarg, strlen(optarg));
 			cmd = COMMAND_ADD_SHARE;
 			break;
 		case 'd':
-			arg_name = g_ascii_strdown(optarg, strlen(optarg));
+			arg_name = ascii_strdown(optarg, strlen(optarg));
 			cmd = COMMAND_DEL_SHARE;
 			break;
 		case 'u':
-			arg_name = g_ascii_strdown(optarg, strlen(optarg));
+			arg_name = ascii_strdown(optarg, strlen(optarg));
 			cmd = COMMAND_UPDATE_SHARE;
 			break;
 		case 'c':
diff -urpN ksmbd-tools-3.1.0/smbuseradd/Makefile.am ksmbd-tools-3.1.0.new/smbuseradd/Makefile.am
--- ksmbd-tools-3.1.0/smbuseradd/Makefile.am	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/smbuseradd/Makefile.am	2020-01-25 02:06:13.558651236 +0400
@@ -1,6 +1,6 @@
 AM_CFLAGS = -I$(top_srcdir)/include $(GLIB_CFLAGS) $(LIBNL_CFLAGS) -fno-common
 LIBS = $(GLIB_LIBS)
-smbuseradd_LDADD = $(top_builddir)/lib/libusmbdtools.la
+smbuseradd_LDADD = $(top_builddir)/lib/libusmbdtools.la -lpthread
 
 sbin_PROGRAMS = smbuseradd
 
diff -urpN ksmbd-tools-3.1.0/smbuseradd/smbuseradd.c ksmbd-tools-3.1.0.new/smbuseradd/smbuseradd.c
--- ksmbd-tools-3.1.0/smbuseradd/smbuseradd.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/smbuseradd/smbuseradd.c	2020-01-26 13:58:13.876726005 +0400
@@ -5,7 +5,6 @@
  *   linux-cifsd-devel@lists.sourceforge.net
  */
 
-#include <glib.h>
 #include <stdlib.h>
 #include <stdio.h>
 #include <unistd.h>
@@ -26,8 +25,8 @@
 
 #include <linux/usmbd_server.h>
 
-static char *arg_account = NULL;
-static char *arg_password = NULL;
+static char *arg_account;
+static char *arg_password;
 
 enum {
 	COMMAND_ADD_USER = 1,
@@ -107,22 +106,22 @@ int main(int argc, char *argv[])
 	while ((c = getopt(argc, argv, "c:i:a:d:u:p:Vvh")) != EOF)
 		switch (c) {
 		case 'a':
-			arg_account = g_strdup(optarg);
+			arg_account = strdup(optarg);
 			cmd = COMMAND_ADD_USER;
 			break;
 		case 'd':
-			arg_account = g_strdup(optarg);
+			arg_account = strdup(optarg);
 			cmd = COMMAND_DEL_USER;
 			break;
 		case 'u':
-			arg_account = g_strdup(optarg);
+			arg_account = strdup(optarg);
 			cmd = COMMAND_UPDATE_USER;
 			break;
 		case 'p':
-			arg_password = g_strdup(optarg);
+			arg_password = strdup(optarg);
 			break;
 		case 'i':
-			pwddb = g_strdup(optarg);
+			pwddb = strdup(optarg);
 			break;
 		case 'V':
 			show_version();
@@ -133,7 +132,7 @@ int main(int argc, char *argv[])
 		case 'h':
 		default:
 			usage();
-	}
+		}
 
 	if (sanity_check_user_name_simple(arg_account)) {
 		pr_err("User name sanity check failure\n");
diff -urpN ksmbd-tools-3.1.0/smbuseradd/user_admin.c ksmbd-tools-3.1.0.new/smbuseradd/user_admin.c
--- ksmbd-tools-3.1.0/smbuseradd/user_admin.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/smbuseradd/user_admin.c	2020-01-26 13:58:13.876726005 +0400
@@ -5,7 +5,6 @@
  *   linux-cifsd-devel@lists.sourceforge.net
  */
 
-#include <glib.h>
 #include <stdlib.h>
 #include <stdio.h>
 #include <unistd.h>
@@ -26,8 +25,8 @@
 
 #define MAX_NT_PWD_LEN 129
 
-static char *arg_account = NULL;
-static char *arg_password = NULL;
+static char *arg_account;
+static char *arg_password;
 static int conf_fd = -1;
 static char wbuf[2 * MAX_NT_PWD_LEN + 2 * USMBD_REQ_MAX_ACCOUNT_NAME_SZ];
 
@@ -136,8 +135,8 @@ static char *get_utf8_password(long *len
 {
 	size_t raw_sz;
 	char *pswd_raw, *pswd_converted;
-	gsize bytes_read = 0;
-	gsize bytes_written = 0;
+	size_t bytes_read = 0;
+	size_t bytes_written = 0;
 
 	pswd_raw = prompt_password(&raw_sz);
 	if (!pswd_raw)
@@ -237,30 +236,30 @@ static void write_user(struct usmbd_user
 	}
 }
 
-static void write_user_cb(gpointer key, gpointer value, gpointer user_data)
+static void write_user_cb(void *value, unsigned long long id, void *user_data)
 {
 	struct usmbd_user *user = (struct usmbd_user *)value;
 
 	write_user(user);
 }
 
-static void write_remove_user_cb(gpointer key,
-				 gpointer value,
-				 gpointer user_data)
+static void write_remove_user_cb(void *value,
+				 unsigned long long key,
+				 void *user_data)
 {
 	struct usmbd_user *user = (struct usmbd_user *)value;
 
-	if (!g_ascii_strcasecmp(user->name, arg_account)) {
+	if (!strcasecmp(user->name, arg_account)) {
 		pr_info("User '%s' removed\n", user->name);
 		return;
 	}
 
-	write_user_cb(key, value, user_data);
+	write_user_cb(value, key, user_data);
 }
 
-static void lookup_can_del_user(gpointer key,
-				gpointer value,
-				gpointer user_data)
+static void lookup_can_del_user(void *value,
+				unsigned long long key,
+				void *user_data)
 {
 	struct usmbd_share *share = (struct usmbd_share *)value;
 	int ret = 0;
@@ -327,7 +326,7 @@ int command_add_user(char *pwddb, char *
 	if (__opendb_file(pwddb))
 		return -EINVAL;
 
-	for_each_usmbd_user(write_user_cb, NULL);
+	foreach_usmbd_user(write_user_cb, NULL);
 	close(conf_fd);
 	return 0;
 }
@@ -366,7 +365,7 @@ int command_update_user(char *pwddb, cha
 	if (__opendb_file(pwddb))
 		return -EINVAL;
 
-	for_each_usmbd_user(write_user_cb, NULL);
+	foreach_usmbd_user(write_user_cb, NULL);
 	close(conf_fd);
 	return 0;
 }
@@ -382,7 +381,7 @@ int command_del_user(char *pwddb, char *
 		return -EINVAL;
 	}
 
-	for_each_usmbd_share(lookup_can_del_user, &abort_del_user);
+	foreach_usmbd_share(lookup_can_del_user, &abort_del_user);
 
 	if (abort_del_user) {
 		pr_err("Aborting user deletion\n");
@@ -392,7 +391,7 @@ int command_del_user(char *pwddb, char *
 	if (__opendb_file(pwddb))
 		return -EINVAL;
 
-	for_each_usmbd_user(write_remove_user_cb, NULL);
+	foreach_usmbd_user(write_remove_user_cb, NULL);
 	close(conf_fd);
 	return 0;
 }
diff -urpN ksmbd-tools-3.1.0/usmbd/Makefile.am ksmbd-tools-3.1.0.new/usmbd/Makefile.am
--- ksmbd-tools-3.1.0/usmbd/Makefile.am	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/usmbd/Makefile.am	2020-01-25 02:05:57.746895560 +0400
@@ -1,6 +1,6 @@
 AM_CFLAGS = -I$(top_srcdir)/include $(GLIB_CFLAGS) $(LIBNL_CFLAGS) -fno-common
 LIBS = $(GLIB_LIBS) $(LIBNL_LIBS)
-usmbd_LDADD = $(top_builddir)/lib/libusmbdtools.la
+usmbd_LDADD = $(top_builddir)/lib/libusmbdtools.la -lpthread
 
 sbin_PROGRAMS = usmbd
 
diff -urpN ksmbd-tools-3.1.0/usmbd/ipc.c ksmbd-tools-3.1.0.new/usmbd/ipc.c
--- ksmbd-tools-3.1.0/usmbd/ipc.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/usmbd/ipc.c	2020-01-25 02:01:29.299043469 +0400
@@ -6,7 +6,6 @@
  */
 
 #include <memory.h>
-#include <glib.h>
 #include <errno.h>
 #include <netlink/netlink.h>
 #include <netlink/msg.h>
